#include <ESP8266WiFi.h> 
#include <SPI.h>

IPAddress ip(192, 168, 178, 216);                 
IPAddress gateway(192,168,178,1);
IPAddress subnet(255,255,255,0);

int light = 2; // number of the light to be switched
 
const char hueHubIP[] = "192.168.178.57";  // Hue hub IP
const char hueUsername[] = "HcOY2PcKRHumATXC4Eu9ksRHBYQyFE4LsuoJ4CmE";  // hue bridge username
const int hueHubPort = 80;


const char ssid[] = "SSID";  //  network SSID (name)
const char pass[] = "password";       // network password



boolean onOffState = false; //to store actual on/off state of lights as reported by Hue bridge

WiFiClient client;


void getHue() 
  {
    if (client.connect(hueHubIP, hueHubPort))
    {
      client.print("GET /api/");
      client.print(hueUsername);
      client.print("/lights/");
      client.print(light);  
      client.println(" HTTP/1.1");
      client.print("Host: ");
      client.println(hueHubIP);
      client.println("Content-type: application/json");
      client.println("keep-alive");
      client.println();
      while (client.connected())
      {
        if (client.available())
        {
          client.findUntil("\"on\":", "\0");
          onOffState = (client.readStringUntil(',') == "true");  
          break;
        }
      }
      client.stop();
    }
  }




void setHue(String command) 
  {
    if (client.connect(hueHubIP, hueHubPort))
     {
        client.print("PUT /api/");
        client.print(hueUsername);
        client.print("/lights/"); 
        client.print(light); 
        client.println("/state HTTP/1.1");
        client.println("keep-alive");
        client.print("Host: ");
        client.println(hueHubIP);
        client.print("Content-Length: ");
        client.println(command.length());
        client.println("Content-Type: text/plain;charset=UTF-8");
        client.println();  // blank line before body
        client.println(command);
        client.stop(); 
      }
  }




void setup()
{
    
   
    WiFi.config(ip, gateway, subnet);
    WiFi.begin(ssid, pass);
  
    while (WiFi.status() != WL_CONNECTED) 
    {
      delay(1);
     
    }
  
}



void loop()
{
  
    getHue();// lights 2 status
    
   
         if (onOffState == true) // if lights are on, send "off" command

              { 
               String command =  "{\"on\": false}"; 
             setHue(command);
              }
            
          else // if lights are off, send "on" command
           
             { 
              String command =  "{\"on\": true}";
             setHue(command);
              
             
             }

 


 ESP.deepSleep(0);
}
